Subject: [Lime] Fwd: [netmod] Motivations for Structuring Models

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Mon, 7 Sep 2015 02:39:37 +0000

LIME,

FYI. This is a post relevant to our WG.

Thanks,

— Carlos.

> Begin forwarded message:
> 
> From: Qin Wu <[email-masked] <mailto:[email-masked]>>
> Subject: RE: [netmod] Motivations for Structuring Models
> Date: August 27, 2015 at 10:05:35 PM EDT
> To: Andy Bierman <[email-masked] <mailto:[email-masked]>>, Rob Shakir <[email-masked] <mailto:[email-masked]>>
> Cc: "[email-masked] <mailto:[email-masked]>" <[email-masked] <mailto:[email-masked]>>, "Carlos Pignataro (cpignata)" <[email-masked] <mailto:[email-masked]>>
> 
> Hi,
> 发件人: netmod [mailto:[email-masked] <mailto:[email-masked]>] 代表 Andy Bierman
> 发送时间: 2015年8月28日 0:25
> 收件人: Rob Shakir
> 抄送: [email-masked] <mailto:[email-masked]>
> 主题: Re: [netmod] Motivations for Structuring Models
> 
> On Thu, Aug 27, 2015 at 6:56 AM, Rob Shakir <[email-masked] <mailto:[email-masked]>> wrote:
> NETMOD,
> 
> One of the chairs encouraged me to post this to the list. I didn’t really find how it fits in to the existing threads, but I wanted to make an observation.
> 
> It strikes me that there is a need to take a step back from the debate of whether /device is a good idea or not.
> 
> As a user of something that results from compiling/generating bindings from a YANG model, I have two requirements:
> 
> I need to be able to compose the right modules to be able to get the functionality that that the thing I’m trying to configure uses.
> Let’s say I want to configure some OAM continuity checking functions - for both MPLS and IP.
> Right now, I have the choice of ‘ietf-lspping’ which defines /lsp-pings, then ‘mplstp-oam’ which defines /mplstp-oam. Presumably then we’ll have ‘ietf-ip-oam’ and then ‘ietf-ipv6-oam’.
> As a developer - how do I figure out which models I need to build my OAM function. Do I have to trawl some directory to find all of the different fragments of OAM
> [Qin]: I think this is also what LIME WG is trying to solve by defining generic YANG model for OAM to provide technology independent framework. Please take a look at LIME WG charter:
> http://datatracker.ietf.org/wg/lime/charter/ <http://datatracker.ietf.org/wg/lime/charter/>
> Do I then need to accept the complexity of dealing with the fact that the structures of LSP pings is completely different to the IP OAM structures? [Given that there is no co-ordination of models, then this will happen.]
>      I think this is something we need to try to avoid. I believe coordination of these models are really needed.
> As someone that is building YANG models, how do I know where I should leaf-ref too.
> Let’s say I want to tie an OAM probe to some protocol liveliness - where do I point my leafref to? At the moment, without some structure, than any path that is specified is pointing to some placeholder location, until we agree where the structure might sit.
>    [Qin]: Two comments:
> 1.       I think draft-rtgyangdt-rtgwg-device-model-00 provide a good structure for these OAM models organization but not limited to provide structure for OAM model organization.
>           +--rw logical-network-elements
>                 +--rw networking-instances
>                    +--rw networking-instance* [networking-instance-name]
>                       +--rw oam-protocols
>                       |  +--rw bfd
>                       |  +--rw cfm
>                       |  +--rw twamp
> 
> 2.       draft-tissa-lime-yang-oam-model also provide a good common structure for OAM models organization.
> LIME WG is chartered to work on generic YANG model for OAM (the relevant draft is draft-tissa-lime-yang-oam-model)and provides a common structure for various OAM technologies, technology specific OAM data models will be worked on respective protocol WGs(e.g., BFD, MPLS).
> 
> Therefore based on LIME charter (http://datatracker.ietf.org/wg/lime/charter/ <http://datatracker.ietf.org/wg/lime/charter/>), the relation with protocol based OAM models can be depicted, for example, as follows:
>                            +-+-+-+-+-+
>                            | LIME gen|
>                            |OAM YANG |
>                            +-+-+-+-+-+
>                                 |
>                                 |
>         +---------------------------------------------------------+
>         |              |               |         |                |
>     +-+-+-+-+-+   +-+-+-+-+-+   +-+-+-+-+-+ +-+-+-+-+-+      +-+-+-+-+-+
>     | CFM     |   | MPLS-TP |   | MPLS    | | IP      | . . .|  foo    |
>     |OAM YANG |   |OAM YANG |   |OAM YANG | |OAM YANG |      |OAM YANG |
>     +-+-+-+-+-+   +-+-+-+-+-+   +-+-+-+-+-+ +-+-+-+-+-+      +-+-+-+-+-+
>           |             |             |           |              |
>           |       +-+-+-+-+-+   +-+-+-+-+-+       |          +-+-+-+-+-+
>           |       | MPLS-TP |   | MPLS    |       |     . . .|  foo    |
>           |       |sub tech |   |sub tech |       |          |sub tech |